<?php declare(strict_types = 1);

namespace Itdatex\EInvoiceCore\Vendor\PHPStan\PhpDocParser\Ast\NodeVisitor;

use Itdatex\EInvoiceCore\Vendor\PHPStan\PhpDocParser\Ast\AbstractNodeVisitor;
use Itdatex\EInvoiceCore\Vendor\PHPStan\PhpDocParser\Ast\Attribute;
use Itdatex\EInvoiceCore\Vendor\PHPStan\PhpDocParser\Ast\Node;

final class CloningVisitor extends AbstractNodeVisitor
{

	public function enterNode(Node $originalNode)
	{
		$node = clone $originalNode;
		$node->setAttribute(Attribute::ORIGINAL_NODE, $originalNode);

		return $node;
	}

}
